	.text
.globl b_add_h
	.type	b_add_h, @function
b_add_h:
#ifdef ARCH64
			/* %ecx is count */
			/* %rdx is b     */
	mov %rsi, %rax 	/* %rsi is a     */
			/* %rdi is out   */

	mov %rcx, %rsi
	shrl $2, %ecx
	test $3, %esi
	jz Loop

	incl %ecx
	andl $3, %esi
	subl $4, %esi
	neg %esi
	shll $3, %esi
	sub %rsi, %rdx
	sub %rsi, %rax
	sub %rsi, %rdi
	shrl $1, %esi
	lea (Loop-3)(%rsi, %rsi, 2), %rsi
	jmp *%rsi

Loop:	mov (%rax), %rsi
	adc (%rdx), %rsi
	mov %rsi, (%rdi)
	mov 8(%rax), %rsi
	adc 8(%rdx), %rsi
	mov %rsi, 8(%rdi)
	mov 16(%rax), %rsi
	adc 16(%rdx), %rsi
	mov %rsi, 16(%rdi)
	mov 24(%rax), %rsi
	adc 24(%rdx), %rsi
	mov %rsi, 24(%rdi)
	
	lea 32(%rax), %rax
	lea 32(%rdx), %rdx
	lea 32(%rdi), %rdi
	decl %ecx
	jnz Loop
	xor %rax, %rax
	setb %al

#else
	pushl %edi
	pushl %esi
	movl 24(%esp), %ecx  	/* count */
	movl 20(%esp), %edx 	/* b     */
	movl 16(%esp), %eax 	/* a     */
	movl 12(%esp), %edi 	/* out   */

	movl %ecx, %esi
	shrl $2, %ecx
	test $3, %esi
	jz Loop

	incl %ecx
	andl $3, %esi
	subl $4, %esi
	neg %esi
	shll $2, %esi
	subl %esi, %edx
	subl %esi, %eax
	subl %esi, %edi
	shrl $2, %esi
	leal (Loop-3)(%esi, %esi, 8), %esi
	jmp *%esi

Loop:	movl (%eax), %esi
	adcl (%edx), %esi
	movl %esi, (%edi)
	movl 4(%eax), %esi
	adcl 4(%edx), %esi
	movl %esi, 4(%edi)
	movl 8(%eax), %esi
	adcl 8(%edx), %esi
	movl %esi, 8(%edi)
	movl 12(%eax), %esi
	adcl 12(%edx), %esi
	movl %esi, 12(%edi)
	
	leal 16(%eax), %eax
	leal 16(%edx), %edx
	leal 16(%edi), %edi
	decl %ecx
	jnz Loop
	xorl %eax, %eax
	setb %al
	popl %esi
	popl %edi
#endif

	ret
