	.text
.globl b_multaddw_h
	.type	b_multaddw_h, @function
b_multaddw_h:
#ifdef ARCH64
	push %rbx
	/* %ecx is size */
	/* %edx is word */
	/* %rsi is a    */
	/* %rdi is out  */
	xor %rbx, %rbx
        mov %rdx, -8(%rsp)

	mov %rcx, %rax
	shr $2, %ecx
	test $3, %eax
	jz Loopma

	inc %ecx
	and $3, %eax
	subl $4, %eax
	neg %eax
	shll $3, %eax
	sub %rax, %rsi
	sub %rax, %rdi
	shrl $3, %eax
	imul $27, %eax, %eax
	lea (Loopma-2)(%rax), %rax
	jmp *%rax

Loopma:	mov (%rsi), %rax
	mulq -8(%rsp)
	add %rbx, %rax
	adc $0, %rdx
	add %rax, (%rdi)
	adc $0, %rdx
	mov %rdx, %rbx

	mov 8(%rsi), %rax
	mulq -8(%rsp)
	add %rbx, %rax
	adc $0, %rdx
	add %rax, 8(%rdi)
	adc $0, %rdx
	mov %rdx, %rbx

	mov 16(%rsi), %rax
	mulq -8(%rsp)
	add %rbx, %rax
	adc $0, %rdx
	add %rax, 16(%rdi)
	adc $0, %rdx
	mov %rdx, %rbx

	mov 24(%rsi), %rax
	mulq -8(%rsp)
	add %rbx, %rax
	adc $0, %rdx
	add %rax, 24(%rdi)
	adc $0, %rdx
	mov %rdx, %rbx

	lea 32(%rsi), %rsi
	lea 32(%rdi), %rdi
	decl %ecx
	jnz Loopma
	xor %rax, %rax
	add %rbx, (%rdi)
	adc $0, %rax
	pop %rbx
#else
	pushl %edi
	pushl %esi
	pushl %ebx
	movl 28(%esp), %ecx	/* size */
	/*movl 24(%esp), ??*/	/* word */
	movl 20(%esp), %esi	/* a    */
	movl 16(%esp), %edi	/* out  */
	xorl %ebx, %ebx

	movl %ecx, %eax
	shrl $2, %ecx
	test $3, %eax
	jz Loopma

	incl %ecx
	andl $3, %eax
	subl $4, %eax
	negl %eax
	shll $2, %eax
	subl %eax, %esi
	subl %eax, %edi
        leal (Loopma-2)(%eax, %eax, 4), %eax
	jmp *%eax

Loopma:	movl (%esi), %eax
	mull 24(%esp)
	addl %ebx, %eax
	adcl $0, %edx
	addl %eax, (%edi)
	adcl $0, %edx
	movl %edx, %ebx

	movl 4(%esi), %eax
	mull 24(%esp)
	addl %ebx, %eax
	adcl $0, %edx
	addl %eax, 4(%edi)
	adcl $0, %edx
	movl %edx, %ebx

	movl 8(%esi), %eax
	mull 24(%esp)
	addl %ebx, %eax
	adcl $0, %edx
	addl %eax, 8(%edi)
	adcl $0, %edx
	movl %edx, %ebx

	movl 12(%esi), %eax
	mull 24(%esp)
	addl %ebx, %eax
	adcl $0, %edx
	addl %eax, 12(%edi)
	adcl $0, %edx
	movl %edx, %ebx

	leal 16(%esi), %esi
	leal 16(%edi), %edi
	decl %ecx
	jnz Loopma
	xorl %eax, %eax
	addl %ebx, (%edi)
	adcl $0, %eax
	popl %ebx
	popl %esi
	popl %edi
#endif
	ret
